﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.NetworkInformation;

namespace GetHostName
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void buttonProcess_Click(object sender, EventArgs e)
        {
            this.backgroundWorkerProcess.RunWorkerAsync();
        }

        private void backgroundWorkerProcess_DoWork(object sender, DoWorkEventArgs e)
        {
            try
            {
                int startIP = int.Parse(this.textBoxIPStart.Text.Trim());
                int endIP = int.Parse(this.textBoxIPEnd.Text.Trim());
                int timeOut = int.Parse(this.textBoxTimeOut.Text.Trim());
                this.richTextBoxOutput.Text = "";
                for (int i = startIP; i < endIP + 1; i++)
                {
                    try
                    {
                        string currentIP = this.textBoxIP.Text.Trim() + i.ToString();
                        this.labelStatus.Text = "正在ping " + currentIP;
                        Ping pingSender = new Ping();
                        //Ping 选项设置  
                        PingOptions options = new PingOptions();
                        options.DontFragment = true;
                        //测试数据  
                        string data = "get hostname";
                        byte[] buffer = Encoding.ASCII.GetBytes(data);
                        //设置超时时间  
                        int timeout = timeOut;
                        //调用同步 send 方法发送数据,将返回结果保存至PingReply实例  
                        PingReply reply = pingSender.Send(currentIP, timeout, buffer, options);
                        if (reply.Status == IPStatus.Success)
                        {
                            string responseIP = reply.Address.ToString();
                            IPHostEntry myscanhost = Dns.GetHostByAddress(reply.Address.ToString());
                            this.richTextBoxOutput.AppendText("响应的主机IP：" + responseIP + "       主机名：" + myscanhost.HostName.ToString());
                            this.richTextBoxOutput.AppendText("\n");

                        }
                    }
                    catch (Exception ex)
                    {
                        this.richTextBoxOutput.AppendText(ex.Message);
                        this.richTextBoxOutput.AppendText("\n");
                    }
                }
                this.richTextBoxOutput.AppendText("完成");
                this.labelStatus.Text = "完成";
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message);
                this.richTextBoxOutput.AppendText("\n");
            }
        }

    }
}
